SystemOrganization addCategory: #'OMeta2-Exp'!

OMeta2 subclass: #LSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2-Exp'!

!LSystem commentStamp: 'sn 9/16/2014 17:17' prior: 0!
TurtleSimple initialize.

"Koch snowflake"

|tree frac|
tree := LSystem matchAll: '5; F=F-F++F-F; G=; F++F++F' with: #start.  
frac := LSystemGen matchAll: tree with: #gen.
TurtleSimple matchAll: frac with: #start withArgs:{60. 1}.

"Sierpinski triangle"

|tree frac|
tree := LSystem matchAll: '7; F=F--F--F--G; G=GG; F--F--F' with: #start. 
frac := LSystemGen matchAll: tree with: #gen.
TurtleSimple matchAll: frac with: #start withArgs:{120. 10}.

"Sierpinski curve"

|tree frac|
tree := LSystem matchAll: '5; A=B-A-B; B=A+B+A; A' with: #start. 
frac := LSystemGen matchAll: tree with: #gen.
TurtleSimple matchAll: frac with: #start withArgs:{60. 10}.

"Dragon"

|tree frac|
tree := LSystem matchAll: '12; X=X+YF+; Y=-FX-Y; FX' with: #start. 
frac := LSystemGen matchAll: tree with: #gen.
TurtleSimple matchAll: frac with: #start withArgs:{90. 5}.


LSystem drawFromCol: frac line: 10 angle: 60.
!

!LSystem class methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 14:17'!
drawFromCol: aCol line: aWidth angle: angle

	|pen sym |

	pen := Pen new.

	1 to: aCol size do:[:each|
		sym := (aCol at: each).
		(sym isLetter) ifTrue:[
			pen go: aWidth.
			].
	
		(sym = $+)  ifTrue:[ pen turn: angle].
		(sym = $-)  ifTrue:[ pen turn: (-1)*angle].
	].! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/14/2014 01:21'!
applyRule=
	"F":n -> [self rule] 
| symbols
! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/14/2014 01:59'!
readRule=
	letter:n -> [n]
	| symbols
	! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 14:29'!
start=
	<digit*>:d ";" spaces
	letter:f "=" spaces readRule*:a ";" spaces
	letter:g "=" spaces readRule*:b ";" spaces
	readRule*:n spaces -> [{d asNumber. {{f asCharacter. a}. {g asCharacter.  b}}.  n}]
	

! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 13:33'!
symbols=
	("-" | "+"):n -> [n asCharacter] ! !

OMeta2 subclass: #LSystemGen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2-Exp'!

!LSystemGen commentStamp: 'sn 9/16/2014 12:21' prior: 0!
LSystem matchAll: 'I: 2; F: F--F--F--G; G: GG; LS: F--F--F' with: #start. 
LSystemGen matchAll: {3. {$F. #($c $+ $F)}. #($F $G $- $G)} with: #testRule.

"sierpinski triangle"
'F': 'F--F--F--G'  {$F. #($F $- $- $F $- $- $F $- $- $G)}
'G': 'GG'		{$G. #($G $G)}
'F--F--F'        #($F $- $- $F $- $- $F)

|triangle|
triangle := LSystemGen matchAll: {3. { {$F. #($F $- $- $F $- $- $F $- $- $G)}.  {$G. #($G $G)}}. #($F $- $- $F $- $- $F)} with: #testRule.
LSystem drawFromCol: triangle.!

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/15/2014 19:16'!
flatCollection: aCol
	
	^aCol gather:[:each| 
	each select:[:c| c isCharacter]
] ! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 14:31'!
gen 0 {rules} {line}:t = [t],
	gen _:n _:g takeRule(g):k= gen(n-1. g. k):m -> [m]! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/15/2014 17:59'!
line=
	(letter | symbols)*! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/15/2014 19:48'!
rules=
	{letter {line}}*! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 12:58'!
selectRule: aRules for: aChar
	
		|rules|
		rules := aRules select:[:each| 
			(each first = aChar)].
 		rules ifNotEmpty:[^rules first second].
		^{aChar}

	! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/15/2014 17:49'!
symbols=
	($- | $+):n -> [n asCharacter]! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 13:01'!
takeRule :g =
	{takeRuleFor(g)*:m} -> [self flatCollection: m ]! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 13:01'!
takeRuleFor :g =
	letter:k -> [self selectRule: g for: k]
| symbols:n -> [{n asCharacter}]! !

OMeta2 subclass: #TurtleSimple
	instanceVariableNames: ''
	classVariableNames: 'Turtle'
	poolDictionaries: ''
	category: 'OMeta2-Exp'!

!TurtleSimple class methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 15:54'!
initialize
	"self initialize."
	Turtle := Pen new.! !

!TurtleSimple methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 16:07'!
start :angle :line=
	(letter -> [Turtle go: line]
| $+ -> [Turtle turn: angle]
| $- -> [Turtle turn: ((-1)*angle)])*! !
TurtleSimple initialize!
